
let pi = 4. *. atan 1.

let x r n0 nmax theta idx = r *. (cos (2. *. pi *. (theta +. float (idx + n0)) /. (float nmax)))
let y r n0 nmax theta idx = r *. (sin (2. *. pi *. (theta +. float (idx + n0)) /. (float nmax)))

let p (x_c, y_c) r n0 nmax theta idx = (x_c +. (x r n0 nmax theta idx), y_c +. (y r n0 nmax theta idx))

let race (x_i, y_i) r_i (x_o, y_o) r_o n0 = 
	let rec race_points ptl nmax idx =
		let ptl_cur = List.append ptl [p (x_i, y_i) r_i n0 nmax 0. idx; p (x_o, y_o) r_o n0 nmax 0. idx] in
		if idx >= nmax then ptl_cur
		else race_points ptl_cur nmax (idx+1)
	in
	race_points [] 50 0

let ball (x_c, y_c) theta =
	let rec ball_points ptl nmax idx =
		let ptl_cur = List.append ptl [ (x_c +. (x 0.16 0 50 theta idx), y_c +. (y 0.16 0 50 theta idx)) ] in
		if idx >= nmax then ptl_cur
		else ball_points ptl_cur nmax (idx+1)
	in
	ball_points [] 50 0 


let cnt = ref 0
let cnt_ball = ref 0

let () =
  ignore (Glut.init Sys.argv);
  Glut.initDisplayMode ~double_buffer:true ();
  Glut.initWindowSize ~w:512 ~h:512;
  ignore (Glut.createWindow ~title:"LablGL Bearing Demo");
  GlClear.color (0.0, 0.0, 0.0);
  GlDraw.shade_model `smooth;
  let render () =
    GlMat.mode `projection;
    GlMat.load_identity ();
    GluMat.ortho2d ~x:(-5., 5.) ~y:(-5., 5.);
    GlMat.mode `modelview;
    GlMat.load_identity ();
    GlClear.clear [ `color ];
    GlDraw.begins `quad_strip;
    List.iter (fun p -> GlDraw.color(0.5,0.5,0.5); GlDraw.vertex2 p) (race (0., 0.) 2.0 (0., 0.) 2.5 0);
    GlDraw.ends ();

		let (x0, y0) = (0.05 *. cos (2. *. pi *. (float !cnt) /. 50.) , 0.05 *. sin (2. *. pi *. (float !cnt) /. 50.) ) in
		GlDraw.begins `quad_strip;
    List.iteri (fun k p -> if k <= 5 then GlDraw.color (0.7,0.7,0.7) else GlDraw.color(0.5,0.5,0.5); GlDraw.vertex2 p) (race (x0, y0) 1.2 (x0, y0) 1.6 !cnt);
    GlDraw.ends ();

		for n = 0 to 8 do
			let rb = 1.8 +. 0.02 *. cos (2. *. pi *. ((float !cnt) /. 50. -. (float n) /. 8.)) in
			GlDraw.begins `polygon;
    	(*List.iter (fun p -> GlDraw.color(0.6,0.6,0.6); GlDraw.vertex2 p) (ball (rb *. (cos (2. *. pi *. (float n) /. 8.)), rb *. (sin (2. *. pi *. (float n) /. 8.))) (2.*.pi*.(float !cnt_ball) /. 500.)); *)
			List.iteri (fun k p -> if k <= 5 then GlDraw.color(0.7,0.7,0.7) else GlDraw.color (0.5, 0.5, 0.5); GlDraw.vertex2 p) (ball (rb *. (cos (2. *. pi *. (float n) /. 8.)), rb *. (sin (2. *. pi *. (float n) /. 8.))) (2.*.pi*.(float !cnt_ball) /. 50.));
    	GlDraw.ends ();
		done;
		
    Gl.flush ();
    Glut.swapBuffers ();
		cnt := !cnt + 1;
		cnt_ball := !cnt_ball + 10
	in
  Glut.displayFunc ~cb:render;
  Glut.idleFunc ~cb:(Some Glut.postRedisplay);
  Glut.keyboardFunc ~cb:(fun ~key ~x ~y -> if key=27 then exit 0);
  Glut.mainLoop ()
