
let pi = 4. *. atan 1.

(* 複素数の計算 *)
let ( +@ ) z1 z2 = Complex.add z1 z2
let ( -@ ) z1 z2 = Complex.sub z1 z2
let ( *@ ) z1 z2 = Complex.mul z1 z2

let rec pow_n p m = if m <= 0 then 1 else p * pow_n p (m-1)

let mod_value p n m = (n / pow_n p m) mod p
let bit_reversal_index p n l =
  Array.init l (fun k -> mod_value p n k) |> Array.to_list |> List.rev |> List.mapi (fun k b -> b * pow_n p k) |> List.fold_left (+) 0

let bit_reversal p l x = Array.init (Array.length x) (fun k -> x.(bit_reversal_index p k l)) 

let w p m n =
  let t = -2. *. pi *. (float n) /. (float (pow_n p m)) in
  { Complex.re = cos t; im = sin t }

let wp p m n =
  let t = 2. *. pi *. (float n) /. (float (pow_n p m)) in
  { Complex.re = cos t; im = sin t }

(*
let butterfly 
*)
