
Require Import ExtrOcamlNatInt.

(*

 C exp_2pi_i f t ~ (C, f)
 (C0, f) + (C1, f) = (C0 + C1, f)
 d (C, f) = (i_2pi * C, f)
 d ... d (C, f) = (i_2pi * ... * i_2pi * C, f)
 *)

Fixpoint diff {C : Type} (n : nat) (mul_c : C -> C -> C) (u : C*C) : C*C :=
  let (c,w) := u in
  match n with
    | O => u
    | S n' => diff n' mul_c (mul_c w c, w) 
  end.

Lemma order_1st {C : Type} : forall (c w : C) (mul_c : C -> C -> C), diff 1 mul_c (c,w) = ((mul_c w c), w).
Proof.
  intros.
  simpl.
  reflexivity.
Qed.

Lemma order_2nd {C : Type} : forall (c w : C) (mul_c : C -> C -> C), diff 2 mul_c (c, w) = ((mul_c w (mul_c w c)), w).
Proof.
  intros.
  simpl.
  reflexivity.
Qed.

Extraction "diff.ml" diff.