
(* 4 元数の計算 *)

(* 足し算, 引き算, 掛け算 *)
let ( +% ) (w1, x1, y1, z1) (w2, x2, y2, z2) =
  (w1 +. w2, x1 +. x2, y1 +. y2, z1 +. z2)

let ( +% ) (w1, x1, y1, z1) (w2, x2, y2, z2) =
  (w1 -. w2, x1 -. x2, y1 -. y2, z1 -. z2)

let ( *%< ) c (w, x, y, z) = (c*.w, c*.x, c*.y, c*.z)

let ( *% ) (w1, x1, y1, z1) (w2, x2, y2, z2) =
  let w_ret = w1*.w2 -. x1*.x2 -. y1*.y2 -. z1*.z2 in
  let x_ret = w1*.x2 +. x1*.w2 +. y1*.z2 -. z1*.y2 in
  let y_ret = w1*.y2 -. x1*.z2 +. y1*.w2 +. z1*.x2 in
  let z_ret = w1*.z2 +. x1*.y2 -. y1*.x2 +. z1*.w2 in
  (w_ret, x_ret, y_ret, z_ret)


let sqr_abs (w, x, y, z) = w*.w +. x*.x +. y*.y +. z*.z
(* 共役 *)
let conj (w, x, y, z) = (w, -.x, -.y, -.z)
(* 逆元 *)
let inv (w, x, y, z) = (1. /. sqr_abs (w,x,y,z)) *%< (conj (w, x, y, x))

(* 3 次元回転 *)
let rot (x,y,z) (ax, ay, az) theta =
  let p = (0., x, y, z) in
  let a = (0., ax, ay, az) in
  let q = (cos (0.5*.theta), 0., 0., 0.) +% ((sin (0.5*.theta)) *%< a) in
  q *% p *% (inv q)
