type ('a, 'b) prod =
| Pair of 'a * 'b

(** val add_r1 :
    ('a1 -> 'a1 -> 'a1) -> ('a1, 'a1) prod -> ('a1, 'a1) prod -> ('a1, 'a1)
    prod **)

let add_r1 add u v =
  let Pair (u1, u2) = u in
  let Pair (v1, v2) = v in Pair ((add u1 v1), (add u2 v2))

(** val mul_r1 :
    ('a1 -> 'a1 -> 'a1) -> 'a1 -> ('a1, 'a1) prod -> ('a1, 'a1) prod **)

let mul_r1 mul c = function
| Pair (u1, u2) -> Pair ((mul u1 c), (mul u2 c))

(** val tensor_r2 :
    ('a1 -> 'a1 -> 'a1) -> ('a1, 'a1) prod -> ('a1, 'a1) prod -> (('a1, 'a1)
    prod, ('a1, 'a1) prod) prod **)

let tensor_r2 mul u v =
  let Pair (u1, u2) = u in
  let Pair (v1, v2) = v in
  Pair ((Pair ((mul u1 v1), (mul u2 v1))), (Pair ((mul u1 v2), (mul u2 v2))))

(** val add_r2 :
    ('a1 -> 'a1 -> 'a1) -> (('a1, 'a1) prod, ('a1, 'a1) prod) prod -> (('a1,
    'a1) prod, ('a1, 'a1) prod) prod -> (('a1, 'a1) prod, ('a1, 'a1) prod)
    prod **)

let add_r2 add u v =
  let Pair (u1, u2) = u in
  let Pair (u11, u12) = u1 in
  let Pair (u21, u22) = u2 in
  let Pair (v1, v2) = v in
  let Pair (v11, v12) = v1 in
  let Pair (v21, v22) = v2 in
  Pair ((Pair ((add u11 v11), (add u12 v12))), (Pair ((add u21 v21),
  (add u22 v22))))

(** val mul_r2 :
    ('a1 -> 'a1 -> 'a1) -> 'a1 -> (('a1, 'a1) prod, ('a1, 'a1) prod) prod ->
    (('a1, 'a1) prod, ('a1, 'a1) prod) prod **)

let mul_r2 mul c = function
| Pair (u1, u2) ->
  let Pair (u11, u12) = u1 in
  let Pair (u21, u22) = u2 in
  Pair ((Pair ((mul c u11), (mul c u12))), (Pair ((mul c u21), (mul c u22))))

